---
name: Bug report
about: Report a bug in ARTIQ    

---

<!-- Above are non-Markdown tags for Github auto-prompting issue type. Template based on pylint: https://raw.githubusercontent.com/PyCQA/pylint/master/.github/ISSUE_TEMPLATE/ -->

# Bug Report

<!-- Thanks for reporting a bug report to ARTIQ! You can also discuss issues and ask questions on IRC (the [#m-labs channel on freenode](https://webchat.freenode.net/?channels=m-labs) or on the [forum](https://forum.m-labs.hk). Please check Github/those forums to avoid posting a repeat issue.

Context helps us fix issues faster, so please include the following when relevant:
-->

## One-Line Summary

Short summary.

## Issue Details

### Steps to Reproduce

1. Step 1.
2. Step 2.
3. Step 3.

### Expected Behavior

Behavior

### Actual (undesired) Behavior

* Text description
* Log message, tracebacks, screen shots where relevant

### Your System (omit irrelevant parts)

* Operating System:
* ARTIQ version: (with recent versions of ARTIQ, run ``artiq_client --version``)
* Version of the gateware and runtime loaded in the core device: (in the output of ``artiq_coremgmt -D .... log``)
* If using Conda, output of `conda list` (please submit as a file attachment, as this tends to be long)
* Hardware involved:

<!--
For in-depth information on bug reporting, see:

http://www.chiark.greenend.org.uk/~sgtatham/bugs.html https://developer.mozilla.org/en-US/docs/Mozilla/QA/Bug_writing_guidelines
-->
